// (c) UK Andrew Giddings 2003
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public Licence as published by the
// Free Software Foundation; either version 2 of the Licence, or (at your
// option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public Licence
// for more details.  (http://www.gnu.org/licenses/gpl.txt)

package uk.co.cix.gidds.io;

import java.io.*;

/*******************************************************************************
* This interface is implemented by apps that process character streams, e.g.
* text formatting or other processing.  Implementing this interface enables you
* to easily create a standard command-line app by passing it to
* {@link uk.co.cix.gidds.misc.FileAppWrapper}.<p>
*
* Rather than extend {@link FilterReader} or {@link FilterWriter}, which would
* need the wrapper to control the process and the number of characters read,
* this allows filters to read character-by-character, line-by-line,
* section-by-section or even the whole file at once, as necessary.<p>
*
* The filename, options, &c are available as static fields and methods of
* FileAppWrapper.
*
* @author Andrew Giddings
*******************************************************************************/

public interface StreamFilter
{
	/**
	* @param in The stream to read.
	* @param out The stream to write.
	**/
	public void filterStream(BufferedReader in, BufferedWriter out)
		throws Exception;
}
