// (c) UK Andrew Giddings 2003
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public Licence as published by the
// Free Software Foundation; either version 2 of the Licence, or (at your
// option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public Licence
// for more details.  (http://www.gnu.org/licenses/gpl.txt)

package uk.co.cix.gidds.ui;

import java.awt.*;

/*******************************************************************************
* A decoration of Dialog, which just centres the dialog over its parent
* Frame.  (EPOC dialogs otherwise seem to go to the top left.).
* It also sets a default font.
*
* @author Andrew Giddings
*******************************************************************************/

public class CentredDialog
	extends Dialog
{
	protected Frame parent;

	public CentredDialog(Frame parent)
	{
		super(parent);
		this.parent = parent;
		setFont(UIUtils.DEFAULT_FONT);
	}

	public CentredDialog(Frame parent, boolean isModal)
	{
		super(parent, isModal);
		this.parent = parent;
		setFont(UIUtils.DEFAULT_FONT);
	}

	public CentredDialog(Frame parent, String title)
	{
		super(parent, title);
		this.parent = parent;
		setFont(UIUtils.DEFAULT_FONT);
	}

	public CentredDialog(Frame parent, String title, boolean isModal)
	{
		super(parent, title, isModal);
		this.parent = parent;
		setFont(UIUtils.DEFAULT_FONT);
	}

	public void setVisible(boolean b)
	{
		if (b)
			UIUtils.centreOverComponent(this, parent);
		super.setVisible(b);
	}
}
